<div class="mat-elevation-z8">
  <div class="Filter">
      <mat-form-field>
          <input id="filter" matInput (keyup)="applyFilter($event.target.value)" placeholder="Filter">
      </mat-form-field>
      <form class="date-block" [formGroup]="filterForm">
            <mat-form-field>
                <input matInput [matDatepicker]="fromDate" placeholder="from Date"
                    formControlName="fromDate">
                <mat-datepicker-toggle matSuffix [for]="fromDate"></mat-datepicker-toggle>
                <mat-datepicker #fromDate></mat-datepicker>
            </mat-form-field>
            <mat-form-field>
                <input matInput [matDatepicker]="toDate" placeholder="to Date"
                    formControlName="toDate">
                <mat-datepicker-toggle matSuffix [for]="toDate"></mat-datepicker-toggle>
                <mat-datepicker #toDate></mat-datepicker>
            </mat-form-field>
        <button id="Datebtn"  mat-raised-button color="primary" class="primary"
            (click)="applyDateFilter(filterForm.value)">Submit</button>
    </form>
  </div>
  <table mat-table class="full-width-table" matSort aria-label="Elements">
      <!-- Id Column -->
      <ng-container matColumnDef="id">
          <th mat-header-cell *matHeaderCellDef>Id</th>
          <td mat-cell *matCellDef="let activity">{{activity.id}}</td>
          <td mat-footer-cell *matFooterCellDef></td>
      </ng-container>
      <!-- StudentId Column -->
      <ng-container matColumnDef="activityName">
          <th mat-header-cell *matHeaderCellDef>Activity Name</th>
          <td mat-cell *matCellDef="let activity">{{activity.activityName}}</td>
          <td mat-footer-cell *matFooterCellDef></td>
      </ng-container>
      <ng-container matColumnDef="ActivityDate">
          <th mat-header-cell *matHeaderCellDef>Date</th>
          <td mat-cell *matCellDef="let activity">{{activity.activityDate | date :'d MMM yyyy'}}</td>
          <td mat-footer-cell *matFooterCellDef></td>
      </ng-container>
      <!-- Name Column -->
      <ng-container matColumnDef="hostTeacher">
          <th mat-header-cell *matHeaderCellDef mat-sort-header>Host Teacher</th>
          <td mat-cell *matCellDef="let activity">{{activity.hostTeacher}}</td>
          <td mat-footer-cell *matFooterCellDef> </td>
      </ng-container>
      <!-- Surname Column -->
      <ng-container matColumnDef="activityLocation">
          <th mat-header-cell *matHeaderCellDef>Location</th>
          <td mat-cell *matCellDef="let activity">{{activity.activityLocation}}</td>
          <td mat-footer-cell *matFooterCellDef></td>
      </ng-container>
      <!-- Gpa Column -->
      <ng-container matColumnDef="periodRegistration">
          <th mat-header-cell *matHeaderCellDef>Registration Time</th>
          <td mat-cell *matCellDef="let activity">{{activity.periodRegistration}}</td>
          <td mat-footer-cell *matFooterCellDef></td>
      </ng-container>
      <!-- image Column -->
      <ng-container matColumnDef="activityTime">
          <th mat-header-cell *matHeaderCellDef class="center-text">Time</th>
          <td mat-cell *matCellDef="let activity" class="center-text">
            {{activity.activityDate | date :'shortTime'}}
          </td>
          <td mat-footer-cell *matFooterCellDef></td>
      </ng-container>

      <ng-container matColumnDef="activityDescription">
          <th mat-header-cell *matHeaderCellDef class="center-text">Description</th>
          <td mat-cell *matCellDef="let activity" class="center-text">
              {{activity.activityDescription}}
          </td>
          <td mat-footer-cell *matFooterCellDef></td>
      </ng-container>

      <ng-container matColumnDef="Detail">
          <th mat-header-cell *matHeaderCellDef class="center-text">Enroll</th>
          <td mat-cell *matCellDef="let activity" class="center-text">
              <button id="submit" mat-raised-button color="warn"
                  [routerLink]="['../activity-detail/',activity.id]">Detail</button>
          </td>
          <td mat-footer-cell *matFooterCellDef></td>
      </ng-container>

      <ng-container matColumnDef="Enroll">
          <th mat-header-cell *matHeaderCellDef class="center-text">Enroll</th>
          <td mat-cell *matCellDef="let activity" class="center-text">
              <button id="submit" mat-raised-button color="primary" type="submit" [routerLink]="['../enrolled']"
                  (click)="Enroll(activity)">Enroll</button>
          </td>
          <td mat-footer-cell *matFooterCellDef></td>
      </ng-container>
      <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
      <tr mat-row *matRowDef="let row; columns: displayedColumns;"></tr>
      <tr mat-footer-row *matFooterRowDef="displayedColumns"></tr>
  </table>

  <mat-paginator #paginator [length]="dataSource?.data.length" [pageIndex]="0" [pageSize]="50"
      [pageSizeOptions]="[25, 50, 100, 250]">
  </mat-paginator>
</div>